<template>
  <table class="table">
    <thead>
      <tr>
        <th scope="col">№</th>
        <template v-for="column in columns">
          <th scope="col" :key="column">
            {{ column }}
          </th>
        </template>
        <th scope="col"></th>
      </tr>
    </thead>
    <tbody>
      <template v-for="(row, rowIndex) in processedRows">
        <tr :key="rowIndex">
          <th scope="row">{{ rowIndex + 1 }}</th>
          <template v-for="(value, colIndex) in row">
            <td :key="colIndex">
                <template v-if="isEditableCell(rowIndex, colIndex)">
                  <input type="text" :value="value"
                    @keyup.esc="onCellEditingCancel()"
                    @keyup.enter="onCellEditingCommit(rowIndex, colIndex, $event)" />
                </template>
                <template v-else>
                  <span @click="onCellEditingStart(rowIndex, colIndex, $event)">{{ value }}</span>
                </template>
            </td>
          </template>
          <td>
            <div class="dropdown">
              <b-dropdown id="ddown-offset" offset="-170" class="m-2" size="sm" variant="light">
                <b-dropdown-item-button v-if="isNextRowExist(rowIndex, -1)" @click="onMoveRow(rowIndex, -1)">&uarr; {{ $t('components.table.moveUp') }}</b-dropdown-item-button>
                <b-dropdown-item-button v-if="isNextRowExist(rowIndex, 1)" @click="onMoveRow(rowIndex, 1)">&darr; {{ $t('components.table.moveDown') }}</b-dropdown-item-button>
                <b-dropdown-item-button @click="onRemoveRow(rowIndex)">{{ $t('button.delete') }}</b-dropdown-item-button>
              </b-dropdown>
            </div>
          </td>
        </tr>
      </template>
    </tbody>
  </table>
</template>

<script>
import { EventBus } from '@/bus'
import { Store } from '@/store'

export default {
  name: 'Table',
  props: {
    columns: {
      type: Array,
      required: true
    }
  },
  data () {
    // Store data
    return Store.state
  },
  created () {
    // Add row
    EventBus.$on('row:added', this.onAddedRow)

    // Update source data
    this.$on('data:update', () => {
      Store.sourceMergeRows(this.processedRows)
    })
  },
  computed: {
    /**
     * Copy of source
     */
    processedRows () {
      // Remove source.rows array relation
      return [].concat(this.source.rows)
    }
  },
  methods: {
    /**
     * Convert cell index to string
     * @param { Number } rowIndex
     * @param { String } colIndex - col name
     */
    joinCellIndex (rowIndex, colIndex) {
      if (typeof rowIndex !== 'number') { throw new Error('rowIndex is not number') }

      return [rowIndex, colIndex].join('-')
    },

    /**
     * Set editable cell
     * @param { Number } rowIndex
     * @param { String } colIndex - col name
     * @param { MouseEvent } event - click
     */
    onCellEditingStart (rowIndex, colIndex, event) {
      this.editableCell = this.joinCellIndex(rowIndex, colIndex)
    },

    /**
     * Check if cell is editable
     * @param { Number } rowIndex
     * @param { String } colIndex - col name
     */
    isEditableCell (rowIndex, colIndex) {
      return this.editableCell === this.joinCellIndex(rowIndex, colIndex)
    },

    /**
     * Stop cell editing
     * @param { Number } rowIndex
     * @param { String } colIndex - col name
     */
    onCellEditingCancel () {
      this.editableCell = null
    },

    /**
     * Approve changes of cell
     * @param { Number } rowIndex
     * @param { String } colIndex - col name
     * @param { KeyboardEvent } event - press enter
     */
    onCellEditingCommit (rowIndex, colIndex, event) {
      let value = event.target.value
      this.processedRows[rowIndex][colIndex] = value

      this.$emit('data:update')

      // Cancel editing
      this.onCellEditingCancel()
    },

    /**
     * Add new default row
     * @param { Object } row - default row defined in @/lib
     */
    onAddedRow (row) {
      this.processedRows.push(Object.assign({}, row))
      this.$emit('data:update')
    },

    /**
     * Move row up or down
     * @param { Number } rowIndex
     * @param { Number } nextPos - direction of new position UP: -1| DOWN: 1)
     */
    onMoveRow (rowIndex, nextPos) {
      if (!this.isNextRowExist(rowIndex, nextPos)) return

      // Get value of current and next position
      let rows = this.processedRows
      let currentValue = rows[rowIndex]
      let nextValue = rows[rowIndex + nextPos]

      // Set value of current and next position
      this.processedRows[rowIndex] = nextValue
      this.processedRows[rowIndex + nextPos] = currentValue

      this.$emit('data:update')
    },

    /**
     * Check top and bottom edge of table
     * @param { Number } rowIndex
     * @param { Number } nextPos - direction of new position (UP: -1| DOWN: 1)
     */
    isNextRowExist (rowIndex, nextPos) {
      return (this.processedRows[rowIndex + nextPos] !== undefined)
    },

    /**
     * Remove row from data
     * @param { Number } rowIndex
     */
    onRemoveRow (rowIndex) {
      this.processedRows.splice(rowIndex, 1)
      this.$emit('data:update')
    }
  }
}
</script>

<style scoped lang="scss">
  $white-color: #FFFFFF;
  $light-blue-color: #F3F9FF;
  $dark-blue-color: #007bff;

  table {
    background-color: $white-color;
    box-shadow: 0 3px 5px 0 rgba(0,0,0,0.15);
    border-radius: 5px;
    margin-bottom: 70px;

    thead {
      th {
        width: 40%;

        &:first-child,
        &:last-child {
          width: 10%;
        }
      }
      tr {
        &:hover {
          background-color: $white-color;
        }

        &:last-child {
          border-radius: 0 5px 0 0;
        }
      }
    }

    tbody {
      tr {
        &:hover {
          background-color: $light-blue-color;
        }

        & input[type='text'] {
          outline: none;
          border: 1px solid $dark-blue-color;
          border-radius: 3px;
          width: 100%;
        }
      }

      td span {
        cursor: pointer;
        border-bottom: 1px dashed $dark-blue-color
      }
    }
  }
</style>
